



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用类似于中介者模式实现不同VC之间的跳转</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用类似于中介者模式实现不同VC之间的跳转</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 18:08:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在2013年的时候,我们就已经实现了类似于http地址进行页面跳转, 那个时候,主要是用继承ViewController和给 UIViewController和UINavigationController写类别实现的.</p>
<p>这样虽然也实现了,但是还是有一些不美观,耦合的比较严重.</p>
<p>最近看了一篇博文,受里面的启发,自己重新实现了相关的VC跳转</p>
<p>上面有很多类目, 我只是针对其中的一个类目进行代码编写的:</p>
<p>以下是摘自上述博文:</p>
<h1>跨业务页面调用方案的设计</h1>
<p>跨业务页面调用是指，当一个App中存在A业务，B业务等多个业务时，B业务有可能会需要展示A业务的某个页面，A业务也有可能会调用其他业务的某个页面。在小规模的App中，我们直接import其他业务的某个ViewController然后或者push或者present，是不会产生特别大的问题的。但是如果App的规模非常大，涉及业务数量非常多，再这么直接import就会出现问题。</p>
<p>跨业务的页面调用在多业务组成的App中会导致横向依赖。那么像这样的横向依赖，如果不去设法解决，会导致什么样的结果？</p>
<ol><li><p>当一个需求需要多业务合作开发时，如果直接依赖，会导致某些依赖层上端的业务工程师在前期空转，依赖层下端的工程师任务繁重，而整个需求完成的速度会变慢，影响的是团队开发迭代速度。</p></li>
<li><p>当要开辟一个新业务时，如果已有各业务间直接依赖，新业务又依赖某个旧业务，就导致新业务的开发环境搭建困难，因为必须要把所有相关业务都塞入开发环境，新业务才能进行开发。影响的是新业务的响应速度。</p></li>
<li><p>当某一个被其他业务依赖的页面有所修改时，比如改名，涉及到的修改面就会特别大。影响的是造成任务量和维护成本都上升的结果。</p></li></ol>
<p>当然，如果App规模特别小，这三点带来的影响也会特别小，但是在阿里这样大规模的团队中，像天猫／淘宝这样大规模的App，一旦遇上这里面哪怕其中一件事情，就特么很坑爹。</p>
<h1>那么应该怎样处理这个问题？</h1>
<p>让依赖关系下沉。</p>
<p>怎么让依赖关系下沉？引入Mediator模式。</p>
<p>所谓引入Mediator模式来让依赖关系下沉，实质上就是每次呼唤页面的时候，通过一个中间人来召唤另外一个页面，这样只要每个业务依赖这个中间人就可以了，中间人的角色就可以放在业务层的下面一层，这就是依赖关系下沉。</p>
<p>当A业务需要调用B业务的某个页面的时候，将请求交给Mediater，然后由Mediater通过某种手段获取到B业务页面的实例，交还给A就行了。在具体实现这个机制的过程中，有以下几个问题需要解决：</p>
<ol><li>设计一套通用的请求机制，请求机制需要跟业务剥离，使得不同业务的页面请求都能够被Mediater处理</li>
<li>设计Mediater根据请求如何获取其他业务的机制，Mediater需要知道如何处理请求，上哪儿去找到需要的页面</li></ol>
<p>这个看起来就非常像我们web开发时候的URL机制，发送一个Get或Post请求，CGI调用脚本把请求分发给某个Controller下的某个Action，然后返回HTML字符串到浏览器去解析。苹果本身也实现了一套跨App调用机制，它也是基于URL机制来运转的，只不过它想要解决的问题是跨App的数据交流和页面调用，我们想要解决的问题是降低各业务的耦合度。</p>
<p>不过我们还不能直接使用苹果原生的这套机制，因为这套机制不能够返回对象实例。而我们希望能够拿到对象实例，这样不光可以做跨业务页面调用，也可以做跨业务的功能调用。另外，我们又希望我们的Mediater也能够跟苹果原生的跨App调用兼容，这样就又能帮业务方省掉一部分开发量。</p>
<p>------摘自完毕</p>
<p>博文地址:</p>
<p>http://casatwy.com/iosying-yong-jia-gou-tan-viewceng-de-zu-zhi-he-diao-yong-fang-an.html</p>
<p>我这边已经实现了一个类似的,剥离了VC之间的耦合关系.</p>
<p>github地址:</p>
<p>https://github.com/xzjxylophone/RXVCMediator</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwj5nr8.html">ABAP 将单元格设置编辑状态 FORM</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96m7lj8.html">微信&amp;quot&semi;附近的人&amp;quot&semi;新增商家公众号入驻功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvdmxjq.html">wpf&comma;离线状态下部分功能不可用。</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rwzrrq.html">Android 手机卫士--签名文件说明&amp;amp&semi;包名说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql7jn09.html">PHP-- 获取http请求头信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gov6lq.html">方程ax2&plus;bx&plus;c&equals;0&semi;一元二次方程。求根</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xozyg9.html">Android 客户端应用开发的架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkorwq.html">PSPO表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okywpe9.html">android中的Cursor类</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x30rn9.html">Scroll文字滚动js</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd4vw38.html">李洪强iOS开发之使用CycleScrollView实现轮播图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zw0549.html">Fragment详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdw1jm8.html">【转】Linux网络相关查询脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e12d5j9.html">Android开发之处理崩溃异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoj11xq.html">内网穿透&plus;VS2015自带IIS express实现本地调试（微信等需要将开发环境暴漏到外网的情况使用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1l6zdq.html">吐槽版︱MRO-Microsoft R Open快捷键&plus;界面识别&plus;功能设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdrv679.html">js 解决两值交换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwpjpz8.html">PHP无限极分类原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gw2x6q.html">mysql插入报主键冲突，解决方法主键索引重新排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7d10q.html">Django之Form、ModelForm 组件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rg1gye8.html">IDEA第三章----idea常用配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pyp6n8.html">Spring&plus;SpringMVC&plus;MyBatis&plus;easyUI整合优化篇（十三）数据层优化-表规范、索引优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjrlm38.html">windows下nodejs安装及配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo4vdvq.html">windows下编译java源文件的编码错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mewlo6q.html">由于losf引起的pxc启动报错处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kljm29.html">poj 1008</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kljn59.html">文件查找---find</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mewpg6q.html">hdu1541 Stars 树状数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk550z8.html">GROUP BY语句与HAVING语句的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge5z448.html">MyBatis之级联小结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
